#include <iostream>

using namespace std;

int main()
{
    long long n,q;
    cin>>n>>q;
    long long d[n],p[n],puk=0,k[q],x=0,g=0;
    for(int i=0;i<n;i++){
        cin>>d[i]>>p[i];
    }
    for(int i=0;i<q;i++){
        cin>>k[i];
    }
    for(int i=0;i<q;i++){
        for(int j=0;j<n;j++){
            puk+=p[j];
            if(k[i]<d[j]){
                cout<<x<<endl;
                puk=0;
                x=0;
                j=n;
                g++;
            }else if(puk>0){
                if(puk>k[i]||puk>k[i]-d[j]){
                    x+=k[i]-d[j]+1;
                    cout<<x<<endl;
                    x=0;
                    puk=0;
                    j=n;
                    g++;
                }else{
                x+=puk;
                puk=0;
                }
            }
        }
    }
    if(x>0)cout<<x<<endl;
    return 0;
}